#include <complex.h>


/* input part */
extern double wc;        // cyclotron freq of the first component
extern double cv;        // speed of light
extern int num;          // the number of kinds of atoms

extern double *an;       // charge
extern double *wpd;      // plasma freq when >0 or relative dencity
extern double *qm;       // charge over mass
extern double *peth;     // perpendicular thermal velocity
extern double *path;     // parallel thermal velocity
extern double *spa;      // parallel drift velocity ?
extern double *loss0;    //
extern double *bfac;     //
extern double *ppp;      //

extern double xcs;       // min of k
extern double xcl;       // max of k
extern double xst;       // k used to create contour map of D
extern double cxi;       // min of the real part of f
extern double cxa;       // max of the real part of f
extern double cyi;       // mid of the imaginary part of f
extern double cya;       // width of the imparginary part of f

extern double theta;     // the direction of wave propagation

extern int nx, ny, nk;   // resolusions of the real part of f, the imaginary part of f and k respectively

/* output part */

extern complex ff[200];  // should be integrated into *fff //
extern double rrkk[200]; // should be integrated into *rrr //

extern complex *fff[100];// the set of curves of f of dispersion relation
extern double *rrr[100]; // the set of curves of k of dispersion relation










