#include <complex.h>
#include <stdio.h>
#include <float.h>
#define __USE_BSD
#include <math.h>

#include "gtdispc.h"


int wkcurv(complex f, double rkw, double theta)
{
  complex  f2;
  complex h, h2;
  //double rkw;
  const int iext = 195;//200
  double drk;
  complex flast, fold;
  double rklast, rkold;
  int num_ff = 0;
  double rkwold = rkw;
  //rkw = xst;
  drk = - (xcl - xcs)/iext;
  fold = f;
  flast = f;
  rkold = rkw - drk;
  rklast = rkw;
  ff[0] = f;
  rrkk[0] = rkw;
  dd1[0] = dddd1;
  dd2[0] = dddd2;
  dd3[0] = dddd3;
  dd4[0] = dddd4;
  dd5[0] = dddd5;
  dd6[0] = dddd6;
  int test=0;
  while(1)
  {
    double yr, yi;
    double thr;
    double dx = unit*1e6;
    int ic;
    const int icmax= 100;
    ic = 0;
    if(test == 0){
      test = 1;
      rkw += drk/100;
    }else if(test == 2){
      test = 1;
      rkw += drk/100;
    }
    else{
    rkw += drk;
    }
    if(rkw < xcs)
    {
      f = ff[0];
      fold = f;
      drk = -drk;
      rkold = rkwold -drk;
      flast = f;
      rklast = rkwold;
      rkw = rkwold;
      test = 2;
      continue;
    }
    // secant method

    f = flast + (flast - fold)/(rklast - rkold)*drk;
    thr = theta/180*M_PI;
    yr = rkw*sin(thr);
    yi = rkw*cos(thr);
    bessmd(yr);
    f2 = f - dx;
    h2 = htodh(f2, yr, yi);
    while(1)
    {
      complex dh, df;
      double fabss;
      const double fabmin = 1e-3;
      const double fl2 = 1e37;
      h = htodh(f, yr, yi);
      //if(cabs(h) < 1e5) break;
      dh = (h - h2)/(f - f2);
      df = h/dh;
      h2 = h;
      f2 = f;
      f -= df;
      // converge?
      fabss = cabs(f) > fabmin ? cabs(f) : fabmin;
      if(fabs(creal(h)) + fabs(cimag(h)) > fl2)
      {
        /*
        if(ifine <= 0)
        {
        }else if (drk > 0)
        {
        }else
        {
        }
        */
      }
      if(cabs(df)/fabss <= 1e-7 && ic != 0) break; // right?
      if(ic > icmax)break;
      ic++;
      // what is ifine?
    }
    // failed to converge
    if(ic > icmax){
      if(drk>0){
        rrkk[++num_ff] = -DBL_MAX;
       // printf("failed to converge\n");
        num_ff--;
        break;
      }else{
        rkw = xcs -1;
        continue;
      }
    }
    // jump
    double dfr;
    double dfreq = fabs(cxa - cxi)/10; // this should be improved 
    dfr = fabs(cv*drk*1.1) > dfreq ? dfreq : fabs(cv*drk*1.1);
    if(fabs(cimag(f) - cimag(flast)) > dfr){
      if(drk>0){
        rrkk[++num_ff] = -DBL_MAX;
       // printf("break big jump\n");
        num_ff--;
        break;
      }else{
        rkw = xcs -1;
        continue;
      }
    }
    if(fabs(creal(f) - creal(flast)) > dfr){
      if(drk>0){
        rrkk[++num_ff] = -DBL_MAX;
       // printf("break big jump\n");
        num_ff--;
        break;
      }else{
        rkw = xcs -1;
        continue;
      }
    }
    fold = flast;
    rkold = rklast;
    flast = f;
    rklast = rkw;
    ff[++num_ff] = f;
    rrkk[num_ff] = rkw;
    dd1[num_ff] = dddd1;
    dd2[num_ff] = dddd2;
    dd3[num_ff] = dddd3;
    dd4[num_ff] = dddd4;
    dd5[num_ff] = dddd5;
    dd6[num_ff] = dddd6;
    if(num_ff >= 199) break;
  }

  // sort
  sort_cv(rrkk, num_ff, 7, ff, dd1, dd2, dd3, dd4, dd5, dd6);
  /*
  {
    FILE *fp;
    fp = fopen("wkcurv.txt", "w");
    for(int i = 0; i<200; i++)
    {
      if(!isnan(ff[i])) fprintf(fp, "%lf %lf\n", rrkk[i], creal(ff[i]));
    }
    fclose(fp);
  }
  */
  return 0;
}
