#include <complex.h>
#include <stdbool.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>

#include "gtdispc.h"


int wkcurv_v(int numm, double theta)
{
  bool *skip;
  int n_line = 0;
  double drk2 = (xcl - xcs)/200;
  skip = (bool *) malloc(sizeof(bool) * numm);
  for(int i = 0; i < numm; i++) *(skip + i) = false;
  for(int i = 0; i < numm; i++)
  {
    if(!*(skip + i))
    {
      int n_dot;
      wkcurv(*(fans + i), *(rans + i), theta);
      for(n_dot = 0; n_dot < 200; n_dot++){
        if(rrkk[n_dot] == -DBL_MAX) break;
      }
      if(n_dot <= 5) continue;
      n_dot++;
      fff[n_line] = (complex *) malloc (sizeof(complex) * n_dot);
      rrr[n_line] = (double *) malloc (sizeof(double) * n_dot);
      ddd1[n_line] = (complex *) malloc (sizeof(complex) * n_dot);
      ddd2[n_line] = (complex *) malloc (sizeof(complex) * n_dot);
      ddd3[n_line] = (complex *) malloc (sizeof(complex) * n_dot);
      ddd4[n_line] = (complex *) malloc (sizeof(complex) * n_dot);
      ddd5[n_line] = (complex *) malloc (sizeof(complex) * n_dot);
      ddd6[n_line] = (complex *) malloc (sizeof(complex) * n_dot);
      polarity[n_line] = (double *) malloc (sizeof(double) * n_dot);
      eee_x[n_line] = (complex *) malloc (sizeof(complex) * n_dot);
      eee_y[n_line] = (complex *) malloc (sizeof(complex) * n_dot);
      eee_z[n_line] = (complex *) malloc (sizeof(complex) * n_dot);
      for(int j = 0; j < n_dot; j++) *(fff[n_line] + j) = ff[j];
      for(int j = 0; j < n_dot; j++) *(rrr[n_line] + j) = rrkk[j];
      for(int j = 0; j < n_dot; j++) *(ddd1[n_line] + j) = dd1[j];
      for(int j = 0; j < n_dot; j++) *(ddd2[n_line] + j) = dd2[j];
      for(int j = 0; j < n_dot; j++) *(ddd3[n_line] + j) = dd3[j];
      for(int j = 0; j < n_dot; j++) *(ddd4[n_line] + j) = dd4[j];
      for(int j = 0; j < n_dot; j++) *(ddd5[n_line] + j) = dd5[j];
      for(int j = 0; j < n_dot; j++) *(ddd6[n_line] + j) = dd6[j];
      n_line++;
      for(int j = i + 1; j < numm; j++)
      {
        for(int k = 0; k < n_dot; k++)
        {
          if(fabs(*(rans + j) - rrkk[k]) < drk2 && cabs(*(fans + j) -ff[k])/fabs(cxa - cxi) < 1e-2){
            *(skip + j) = true;
          }
        }
      }
    }
  }
  return n_line;
}
