#include <complex.h>
#include <stdlib.h>

#include "gtdispc.h"

int wkregn(void)
{
  double hcdx, hcdy;
  double ymin;

  free(fregn);
  fregn = (complex *) malloc(sizeof(complex)*nx*ny);

  hcdx = (cxa - cxi)/(nx - 1);
  hcdy = 2*cya/(ny - 1);
  ymin = cyi - cya;
  for(int j = 0; j < ny; j++)
  {
    complex fi;
    fi = ymin + j*hcdy;
    for(int i = 0; i < nx; i++)
    {
      *(fregn + nx*j + i) = (cxi + i*hcdx) + I*fi;
    }
  }
  return nx*ny;
}
