A = importdata('whistler_r.txt');
kmin = 0;
kmax = 0.1;
N = 901;

k = kmin:(kmax-kmin)/599:kmax;
[th,r] = meshgrid(0:pi/2/(N-1):pi/2, k);
[X,Y] = pol2cart(th,r);

polor_axis(kmax, 9, 5);
h = pcolor(X,Y,A');
colorbar;
shading flat;