#include <math.h>
#include <complex.h>
#include <float.h>
#include "header.h"

double e_para_to_perp(c_vec E){
  complex Epara;
  c_vec Eperp;
  double nEperp, nEpara;

  Epara = E.z;
  Eperp.x = E.x;
  Eperp.y = E.y;

  nEperp = norm_c_vec(Eperp);
  nEpara = cabs(Epara);

  if(nEperp == 0.) return DBL_MAX;
  else return nEpara/nEperp;

}
