#include <complex.h>
#define __USE_BSD
#include <math.h>
#include "header.h"

// magnitude is not correct
c_vec poynting(c_vec E, double theta , complex w){
  c_vec K, B, P;
  double angle;

  if(cabs(w) == 0){
    P.x = 0; P.y = 0; P.z = 0;
  }else{
    double norm;
    angle = theta/180*M_PI;
    K.x = sin(angle);
    K.y = 0;
    K.z = cos(angle);
    B = cross_product(E,K);
    B.x /= w;
    B.y /= w;
    B.z /= w;
    B.x = conj(B.x);
    B.y = conj(B.y);
    B.z = conj(B.z);
    P = cross_product(E,B);
    P.x = creal(P.x);
    P.y = creal(P.y);
    P.z = creal(P.z);
    norm = sqrt(cabs(P.x*P.x + P.y*P.y + P.z*P.z));
    norm = creal(w) > 0 ? norm : -norm;
    P.x /= norm;
    P.y /= norm;
    P.z /= norm;
  }
  return P;
}

c_vec cross_product(c_vec A, c_vec B){
  c_vec C;
  C.x = A.y*B.z - B.y*A.z;
  C.y = A.z*B.x - B.z*A.x;
  C.z = A.x*B.y - B.x*A.y;
  return C;
}
