#include <complex.h>
#include <float.h>
#include <stdio.h>
#include <stdlib.h>
#include "../LIB/header.h"
#include "headerT.h"

int main(int argc, char* argv[]){
  complex *w, *h1, *h2, *h3, *h4, *h5, *h6;
  double *k;
  
  if(argc != 2){
    printf("illegal number of arguments\n");
    exit(EXIT_FAILURE);
  }

  open_files_h(argv[1]);
  for(int i = 0; i < Data_Num; i++){
    double theta;
    theta = read_h(&k, &w, &h1, &h2, &h3, &h4, &h5, &h6);
    for(int j = 0; j < 600; j++){
      c_vec E;
      double bb;
      E = e_ratio(theta, *(h1+j), *(h2+j), *(h3+j), *(h4+j), *(h5+j), *(h6+j));
      bb = b_k(E, theta , *(w+j));
      
      printf("%e\t", bb);
    }
    printf("\n");
  }

  close_files_h();
}
