#include <complex.h>
#include <float.h>
#include <stdio.h>
#include <stdlib.h>
#include "../LIB/header.h"
#include "headerT.h"

int main(int argc, char* argv[]){
  complex *w, *h1, *h2, *h3, *h4, *h5, *h6;
  char output;
  double *k;
  
  if(argc != 3){
    printf("illegal number of arguments\n");
    exit(EXIT_FAILURE);
  }
  output = *argv[2];
  if(output != 'x' && output != 'y' && output != 'z'){
    printf("The argument is x or y or z\n");
    exit(EXIT_FAILURE);
  }

  open_files_h(argv[1]);
  for(int i = 0; i < Data_Num; i++){
    double theta;
    theta = read_h(&k, &w, &h1, &h2, &h3, &h4, &h5, &h6);
    for(int j = 0; j < 600; j++){
      c_vec E,P;
      double val;
      E = e_ratio(theta, *(h1+j), *(h2+j), *(h3+j), *(h4+j), *(h5+j), *(h6+j));
      P = poynting(E, theta , *(w+j));
      switch (output){
        case 'x': val = creal(P.x); break;
        case 'y': val = creal(P.y); break;
        case 'z': val = creal(P.z); break;
      }
      printf("%e\t", val);
    }
    printf("\n");
  }

  close_files_h();
}
