#include <complex.h>
#include <float.h>
#include <stdio.h>
#include <stdlib.h>
#include "headerT.h"
#include "../LIB/header.h"
#define __USE_BSD
#include <math.h>

int main(int argc, char *argv[]){
  complex *w, *h1, *h2, *h3, *h4, *h5, *h6;
  double *k;
  double Omega, Vpara;
  
  if(argc != 4){
    printf("error\n");
    exit(EXIT_FAILURE);
  }

  Omega = strtod(argv[2], NULL);
  Vpara = strtod(argv[3], NULL);

  open_files_h(argv[1]);
  for(int i = 0; i < Data_Num; i++){
    double theta;
    theta = read_h(&k, &w, &h1, &h2, &h3, &h4, &h5, &h6);
    for(int j = 0; j < 600; j++){
      double kpara, n;
      kpara = *(k+j) * cos(theta*M_PI/180);
      n = creal(*(w + j)) - kpara*Vpara;
      n /= Omega;
      printf("%e\t", n);
    }
    printf("\n");
  }

  close_files_h();
}
