#include <gtk/gtk.h>

/* GRAPH */
extern int gnam; //should be deleted
extern double xclicked;
extern double yclicked;

GtkWidget *my_graph();

void set_xlabel(GtkWidget *, gchar*);
void set_ylabel(GtkWidget *, gchar*);

void set_xrange(GtkWidget *, gdouble, gdouble);
void set_yrange(GtkWidget *, gdouble, gdouble);

gint append_line(GtkWidget *, gdouble*, gdouble*, gint, double, double, double);

void clear_line(GtkWidget *);

void setLogscale(GtkWidget *canvas, gboolean is_logscale, gboolean is_logscale_positive, gboolean isX);

void getLogscale(GtkWidget *canvas, gboolean *is_logscale, gboolean *is_logscale_positive, gboolean isX);

void show_line(GtkWidget *canvas, gint lnum);
void hide_line(GtkWidget *canvas, gint lnum);

gboolean graph_is_visible(GtkWidget *canvas, gint lnum);

void show_numbers(GtkWidget *canvas, gboolean show);

void change_color(GtkWidget *canvas, int num, double r, double g, double b);

gint add_circle(GtkWidget *canvas, double x, double y, double radius, double r, double g, double b);
void clear_circle(GtkWidget *canvas);


/* CONTOUR */
GtkWidget *my_contour(void);

void set_c_values(GtkWidget *w, double *x1, double *y1, double *x2, double *y2, double *val, int length);

void set_c_range(GtkWidget *w, double minimum, double maximum, int range);

void set_c_label(GtkWidget *canvas, gchar *label, gint axis);

#ifndef M_PI
#define M_PI 3.141592
#endif
