#include "graph.h"
#include "state.h"
#include <gtdispc.h>
#include <glib.h>
#include <glib/gstdio.h>

static void swtich_page(GtkButton *button, GtkNotebook *note){
  gint page;
  page = gtk_notebook_get_current_page(note);

  if(page == 0) gtk_notebook_set_current_page(note, 1);
  else          gtk_notebook_set_current_page(note, 0);
}

static void


int main(){
  GtkWidget *dialog, *vbox, *note, *child; 
  option_set os;

  // store options
  os = OS;

  dialog = gtk_dialog_new();
  vbox = GTK_DIALOG(dialog)->vbox;
  note = gtk_notebook_new();

  child = gtk_vbox_new(FALSE, 2);
  {
    GtkWidget *check;
    check = gtk_check_button_new_with_label("H components");
    g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(check_toggled), (gpointer) &(os.o_h));
    gtk_box_pack_start_defaults(GTK_BOX(vbox), check);
  }
  gtk_notebook_append_page(GTK_NOTEBOOK(note), child, gtk_label_new("OUTPUT"));
  g_signal_connect(G_OBJECT(child), "clicked", G_CALLBACK(switch_page), (gpointer) note);

  gtk_notebook_append_page(GTK_NOTEBOOK(note), child, gtk_label_new("CALCULATE90"));
  g_signal_connect(G_OBJECT(child), "clicked", G_CALLBACK(switch_page), (gpointer) note);
  gtk_widget_show_all(dialog);



}
