/* analysis information */

/* axis information */
extern GtkWidget *CanvasWK, *CanvasGK, *CanvasGW;
double frmin, frmax;
double fimin, fimax;
double kmin, kmax;
// log
gboolean log_WK, log_GK, log_GW;

/* line information */
int num_lines;
gboolean *isVisible;

/* polarization information */
GtkDialog *Pol_Dialog;
int pol_line;
int pol_k;
complex pol_f;

/* choosing mode */
gboolean isChoosing;
int choosing_line;

extern GtkWidget *MAIN2;

///////////
extern GtkWidget *R_frmin, *R_frmax, *R_fimin, *R_fimax, *R_kmin, *R_kmax;

char **sname;

extern double normal_x;
extern double normal_y;
extern int state_graph;
#define POL_GRAPH 1





GtkWidget *POL_BUTTON;





typedef struct{
  double wc;        // cyclotron freq of the first component
  double cv;        // speed of light
  int num;          // the number of kinds of atoms

  double *an;       // charge
  double *wpd;      // plasma freq when >0 or relative dencity
  double *qm;       // charge over mass
  double *peth;     // perpendicular thermal velocity sqrt(kbT/m)
  double *path;     // parallel thermal velocity
  double *spa;      // parallel drift velocity ?
  int *loss0;       // 0 bi-Maxwellian 1 loss-cone of AK
  double *bfac;     // beta of AK
  double *ppp;      // rho of AK

  double *rn;       // relative dencity
  double *wp;       // plasma freq

  double b;         // strength of the magnetic field
  double val;       // Alfven velocity

  double theta;     // direction of wave propagation in degree
  double kmin;
  double kmax;
  double wmin;
  double wmax;
  double rmin;
  double rmax;
}reserved_state;

extern reserved_state init_state;

#ifndef M_PI
#define M_PI 3.141592
#endif
extern void for_all_direction(char* filename);


