#include <complex.h>
#include <stdlib.h>
#include <stdarg.h>

#include "gtdispc.h"

void sort_cv(double *d, int length, int num, ...){
  complex **c;
  va_list args;

  c = (complex **) malloc(sizeof(complex **) * num);
  va_start(args, num);
  for(int i = 0; i < num; i++) *(c + i) = va_arg(args, complex *);
  for(int j = 0; j < length; j++){
    for(int i = j+1; i < length; i++){
      if(*(d+j) > *(d+i)){
        double dtemp;
        dtemp = *(d+j);
        *(d+j) = *(d+i);
        *(d+i) = dtemp;
        for(int k = 0; k < num; k++){
          complex ctemp;
          ctemp = *(*(c+k)+j);
          *(*(c+k)+j) = *(*(c+k)+i);
          *(*(c+k)+i) = ctemp;
        }
      }
    }
  }
  va_end(args);
  free(c);
}
