typedef struct{
  complex x;
  complex y;
  complex z;
} c_vec;

extern c_vec e_ratio(double theta, complex h1, complex h2, complex h3, complex h4, complex h5, complex h6);

extern double ellipticity(c_vec E, complex w);

extern double e_para_to_perp(c_vec E);
extern double e_para_to_perp_k(c_vec E, double theta);

extern c_vec poynting(c_vec E, double theta , complex w);
extern double e_by_b(c_vec E, double theta , complex w, double k);

extern c_vec cross_product(c_vec A, c_vec B);
extern complex dot_product(c_vec A, c_vec B);
extern c_vec normalize_c_vec(c_vec A);
extern double norm_c_vec(c_vec A);

extern double b_k(c_vec E, double theta , complex w);
