#include <complex.h>
#include <float.h>
#include <stdio.h>
#include <stdlib.h>
#include "headerO.h"
#include "../LIB/header.h"
#define __USE_BSD
#include <math.h>

int main(int argc, char *argv[]){
  complex **w, **h1, **h2, **h3, **h4, **h5, **h6;
  double **k,pro_angle;
  int iteration;

  iteration = load_kwr(argv[1], &k, &w, &h1, &h2, &h3, &h4, &h5, &h6);
  pro_angle = strtod(argv[2],NULL);
  double thr;
  thr = pro_angle*M_PI/180;

  for(int i = 0; i < iteration; i++){
    for(int j = 0; j < 200; j++){
      c_vec E;
      if(creal(*(*(h1+i)+j)) == -DBL_MAX) break;
      E = e_ratio(pro_angle, *(*(h1+i)+j), *(*(h2+i)+j), *(*(h3+i)+j), *(*(h4+i)+j), *(*(h5+i)+j), *(*(h6+i)+j));
      printf("%e\n", ellipticity(E, *(*(w+i) + j)));
    }
    printf("\n");
  }

}
