extern int load_kwr(char *filename, double ***k, double ***w, double ***r);
extern void free_kwr(int nlines, double **k, double **w, double **r);

extern int load_h(char *filename, complex ***h1, complex ***h2, complex ***h3, complex ***h4, complex ***h5, complex ***h6);
extern void free_h(int nlines, complex **h1, complex **h2, complex **h3, complex **h4, complex **h5, complex **h6);

typedef struct{
  complex x;
  complex y;
  complex z;
} c_vec;

extern c_vec e_ratio(double theta, complex h1, complex h2, complex h3, complex h4, complex h5, complex h6);

extern double ellipticity(c_vec E);

extern double e_para_to_perp(c_vec E);

extern void open_files_h(const char *prefix);
extern void close_files_h(void);
extern double read_h(double **kkk, complex **ww, complex **hh1, complex **hh2, complex **hh3, complex **hh4, complex **hh5, complex **hh6);

extern c_vec poynting(c_vec E, double theta , complex w);
extern c_vec cross_product(c_vec A, c_vec B);

extern complex dot_product(c_vec A, c_vec B);
extern c_vec normalize_c_vec(c_vec A);
