#include <gtk/gtk.h>
#include "graph.h"

int main(int argc, char *argv[]){
  GtkWidget *window, *canvas;
  gtk_init(&argc, &argv);
  
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  canvas = my_graph();
  set_xlabel(canvas, "XLABEL");
  set_ylabel(canvas, "YLABEL");
  set_xrange(canvas, 10,50);
  set_yrange(canvas, 20,90);
  gtk_container_add(GTK_CONTAINER(window), canvas);

  {
    double * xdata;
    xdata  = (double *) g_new0(double, 5);
    *(xdata + 0) = 10;
    *(xdata + 1) = 20;
    *(xdata + 2) = 30;
    *(xdata + 3) = 40;
    *(xdata + 4) = 50;
    double * ydata;
    ydata  = (double *) g_new0(double, 5);
    *(ydata + 0) = 10;
    *(ydata + 1) = 20;
    *(ydata + 2) = 30;
    *(ydata + 3) = 40;
    *(ydata + 4) = 50;
    append_line(canvas, xdata, ydata, 5, 1,0,0);
  }

  {
    double * xdata;
    xdata  = (double *) g_new0(double, 5);
    *(xdata + 0) = 10;
    *(xdata + 1) = 20;
    *(xdata + 2) = 30;
    *(xdata + 3) = 40;
    *(xdata + 4) = 50;
    double * ydata;
    ydata  = (double *) g_new0(double, 5);
    *(ydata + 0) = 30;
    *(ydata + 1) = 40;
    *(ydata + 2) = 50;
    *(ydata + 3) = 60;
    *(ydata + 4) = 70;
    append_line(canvas, xdata, ydata, 5, 0,1,0);
  }
//  setLogscale(canvas, 1, 1, 0);
  gtk_widget_show_all(window);
  gtk_main();
}
