#include <stdbool.h>
/* analysis information */

/* axis information */
extern GtkWidget *CanvasWK, *CanvasGK, *CanvasGW;
double frmin, frmax;
double fimin, fimax;
double kmin, kmax;
// log
gboolean log_WK, log_GK, log_GW;

/* line information */
int num_lines;
gboolean *isVisible;

/* polarization information */
GtkDialog *Pol_Dialog;
int pol_line;
int pol_k;
complex pol_f;

/* choosing mode */
gboolean isChoosing;
int choosing_line;

extern GtkWidget *MAIN2;
extern GtkWidget *MAIN3;

///////////
extern GtkWidget *main2_new(void);
extern GtkWidget *R_frmin, *R_frmax, *R_fimin, *R_fimax, *R_kmin, *R_kmax;

char **sname;

extern double normal_x;
extern double normal_y;





GtkWidget *POL_BUTTON;





typedef struct{
  double wc;        // cyclotron freq of the first component
  double cv;        // speed of light
  int num;          // the number of kinds of atoms

  double *an;       // charge
  double *wpd;      // plasma freq when >0 or relative dencity
  double *qm;       // charge over mass
  double *peth;     // perpendicular thermal velocity sqrt(kbT/m)
  double *path;     // parallel thermal velocity
  double *spa;      // parallel drift velocity ?
  int *loss0;       // 0 bi-Maxwellian 1 loss-cone of AK
  int *kappa;       // 0 bi-Maxwellian 1 loss-cone of AK
  double *bfac;     // beta of AK
  double *ppp;      // rho of AK

  double *rn;       // relative dencity
  double *wp;       // plasma freq

  double b;         // strength of the magnetic field
  double val;       // Alfven velocity

  double theta;     // direction of wave propagation in degree
  double kmin;
  double kmax;
  double wmin;
  double wmax;
  double rmin;
  double rmax;
}reserved_state;

extern reserved_state init_state;

typedef struct{
  // original data
  double *w, *g, *k;
  int length;

  // drawing data
  double color_r, color_g, color_b;
  gboolean isVisible;
  int num;
  int max_g;

  // current graphs
  GList *lines;
}dcurve;

extern dcurve *DCURVE;

extern void reset_dcurve_graphs(dcurve *d);
extern void clear_figures();

#ifndef M_PI
#define M_PI 3.141592
#endif
extern void for_all_direction(char* filename, double t_min, double t_max, int t_n);


extern GtkWidget *main3_new(void);
extern GtkWidget *wlabel, *klabel;
void main3_set_E(complex ex, complex ey, complex ez, complex w);

typedef struct{
  volatile gint click;
  volatile gint line;
  gint selected_line;
}MAIN2S;

#define CLICK_DEL 0
#define CLICK_INFO 1

#define LINE_NORMAL 0
#define LINE_POL 1


extern MAIN2S main2s;

typedef struct{
  bool o_h;
}option_set;

extern option_set OS;
